



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《An Introduction to Signal Smoothing》译文</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《An Introduction to Signal Smoothing》译文</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 07:54:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>最近在做数据平滑相关的工作，正好读到该篇博客，感觉不错，就翻译了一下。原链接：<a href="http://www.alanzucconi.com/2016/06/03/an-introduction-to-signal-smoothing/" rel="external nofollow noreferrer">An Introduction to Signal Smoothing</a></p>
<h1>信号平滑简介</h1>
<p>噪声无处不在，不管是在采集手机游戏的加速度数据还是在测量房间的温度，都会引入误差。即使我们有能力消除所有的误差，测量的结果依旧包含一定程度的不确定性。假如玩家随意点击了一下手机屏幕，他们到底想点击哪里是不确定的。所有这些问题都强迫我们重新思考数据的采集和预处理。</p>
<h2>1. 简介</h2>
<p>滤波器是寻找产生观测数据最可能信号的数学工具。它可以对渗透进传感器的噪声和不确定性进行消除。当前的各种设备，如触屏、游戏手柄、手机和游戏控制器等都是通过传感器采集用户的输入，所以这些设备都不可避免地会引入噪声。所以滤波器在用户体验上扮演着非常重要的角色。 <br /><br />
本博客会介绍关于平滑滤波器的基本知识。将这些知识应用到游戏中会极大提升游戏体验。</p>
<h2>2. 噪声信号</h2>
<p>用一个简单例子来解释噪声是如何干扰信号的。假设一个传感器每隔固定时间采样一下数据，在时刻i产生观测值Si。如果你是游戏开发者，这个传感器很可能是一个控制器，得到的数据可能为：<code>Input.GetAxis("Vertical")</code>。如果你是一个电子工程师，这个传感器可能是电位计，用来测量电压： <code>analogRead(3)</code>。这些时间序列都有一个共同点：都被噪声干扰。下图展示了一个被噪声污染的信号： <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160628222506728"> <br /><br />
在这个例子中，噪声被人工添加到原始信号中。针对原始信号的每一个点Si加上一个随机值：</p>
<div>ni=Si+rand()</div>
<p>如果满足上面的条件，我们就说噪声是满足可加性的，并且是均匀分布的。这时添加的噪声就独立于原始信号。满足可加性的一致性噪声通常来源于固定的外部干扰。</p>
<h2>3. 滑动平均（Moving Average）</h2>
<p>是否能重构被噪声污染的信号呢？答案是：看情况。这依赖于噪声的类型和幅度。减弱噪声的最简单方法被称为滑动平均。该方法基于这样一个假设：独立的噪声不会改变信号的基本结构。如果假设成立，则求几个连续点的平均值就可以减弱噪声。正如其名字所表示的，滑动平均就是求给定点和其邻居的平均值作为信号值。例如，我们对三个点求平均值，则过滤之后的信号为：</p>
<div>Fi=Ni−1+Ni+Ni+13</div>
<p>当获得所有的观测值之后，我们可以定义窗口大小为N=2K+1的滑动平均为：</p>
<div>Fi=1N∑j=−k+kSi−j</div>
<p>在下图中，用窗口大小为6的滑动平均对上图的信号进行处理： <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160628222821131"> <br /><br />
可以看出，原始信号几乎被完整地恢复出来。如果你是开发者，可以用下面的代码实现上述过滤：</p>
<pre class="prettyprint linenums"><code>public float [] MovingAverage (float [] data, int size)<br />
{<br />
    float [] filter = new float [data.length];<br />
    for (int i = points/2; i &lt; data.length-points/2; i++)<br />
    {<br />
        float mean = 0;<br />
        for (var j = -points/2; j &lt; points/2; j++)<br />
            mean += data[i + j];

        filter[i] = mean / size;<br />
    }<br />
    return filter;<br />
}</code></pre>
<p>增加窗长可以进一步减弱噪声的影响，但同时也会使原始信号过度平滑。滑动平均特别适合于连续和平稳的信号。如果信号变化较为剧烈，滑动平均可能会使原始信号的变化大于噪声的消除（也即功不抵过）。 <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160628222923371"> <br /><br />
上图中，虽然滑动平均减小了信号的变化程度，但是完美地重构了信号的线性部分。当我们在处理包含可加性噪声的线性信号时，滑动平均是最好的选择。当然，上面的例子也过于理想化，在实际中很难出现。</p>
<h2>4. 中心化的滑动平均</h2>
<p>上面介绍的滑动平均有个限制：窗口长度N必须为奇数。这样计算的平均值就满足对称性。假如窗口长度N=2k为偶数，此时我们有两种平滑方法（假定k=2）：</p>
<div>MAL4=Ni−2+Ni−1+Ni+Ni+14</div>

<div>MAR4=Ni−1+Ni+Ni+1+Ni+24</div>
<p>上述两个公式都是合法的，没有特别的偏向性。所以我们可以对这两个公式求平均值，获得一个中心化的滑动平均，这通常被称为2×4MA。</p>
<div>2×4MA=12[14(Ni−2+Ni−1+Ni+Ni+1)+14(Ni−1+Ni+Ni+1+Ni+2)]</div>

<div>=Ni−28+Ni−14+Ni4+Ni+14+Ni+28</div>
<p>上面的结果特别像以Ni为中心的滑动平均，但是和前面介绍的滑动平均还是不同的。</p>
<h2>5. 加权滑动平均</h2>
<p>滑动平均中每个点的权重是相同的，一个更加合理的选择是对靠近Si的点赋予更大的权重，这就是加权滑动平均：</p>
<div>Fi=∑j=−k+kSi−jWk+j</div>
<p>Wj的和必须等于1。 <br /><br />
    针对加权滑动平均，可以对前面的滑动平均代码进行下面的修改：</p>
<pre class="prettyprint linenums"><code> for (var j = -points/2; j &lt; points/2; j++)<br />
            mean += data[i + j] * weights[j+points/2];</code></pre>
<p>回过头来重看中心化的滑动平均，我们就可以说2×4MA其实就是权重为1/8,1/4,1/4,1/4,1/8的加权滑动平均。 <br /><br />
    加权的方法不可思议得有效，但是引入了更多的参数。如果你对泛函分析很了解，可能很容易将上面的操作联想到卷积操作符上。通过仔细地挑选权重可以带来很多有趣的性质，例如实现边缘检测或者高斯模糊等。 <br /><br />
    举一个边缘检测的例子，我们对一个方波执行墨西哥帽小波的卷积操作，需要做的就是将权重设置为下述函数上的点：</p>
<div>f(t)=(1−t2)e−t22</div>
<p>然后代码修改成：</p>
<pre class="prettyprint linenums"><code>float[] kernel = new float[10];<br />
for (int i = 0; i &lt;= kernel.length; t ++)<br />
{<br />
    float t = i +4;<br />
    kernel[i] = (1-(t*t)) * Math.exp(-(t*t)/2);<br />
}<br />
</code></pre>
<p>上述卷积函数可以用来进行边缘检测。如果你是一个游戏开发者，上述方法可以用来检测玩家的突然移动，这通常是运动检测的第一步。 <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160628223220543"></p>
<h2>6. 结论</h2>
<p>本博客介绍了信号中的噪声问题以及两种解决方法。需要记住一点，没有一种方法是完美的，每个方法都有其优缺点，我们需要知道它们的适用范围。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2ky13q.html">eclipse中去除build时总是js错误的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ygoo8.html">VScode常用几个前端插件live HTML previewer和debugger for chrome的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1n4jz9.html">Android开源项目&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykv7x9.html">oracle sqlserver mysql数据库分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1yj0k8.html">Async详解之一：流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnp4ld8.html">cocos2dx 3&period;1从零学习（三）&mdash;&mdash;Touch事件（回调，反向传值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ylv4q.html">自己拼接json字符串，现在用Gson来实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jk7jx8.html">CentOS 修改主机名</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdydey9.html">css实现隐藏多余溢出文字并显示省略号</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmn3l8.html">CSS基础：替换元素和非替换元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj21nr8.html">VMware 常见问题及解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3rj69.html">java -cp通配符</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jdvvjq.html">基于ROS和beaglebone的串口通信方式，使用键盘控制移动机器人</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2zzx2q.html">&OpenCurlyDoubleQuote;i词汇&rdquo;宣传文案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vre0q.html">Python中os&period;system和os&period;popen区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2kn0e8.html">U盘量产大致研究思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mje3168.html">SDE操作的许可问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj3g50q.html">图文例解C&plus;&plus;类的多重继承与虚拟继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/9632og49.html">c&plus;&plus;之五谷杂粮---3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj6o2p8.html">ELK平台介绍</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4z5o2n9.html">BeautifulSoup重点复习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1nkydq.html">Extensions in UWP Community Toolkit - WebViewExtensions</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgpved8.html">Java动态代理模式浅析</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m0zvm8.html">java8接口定义增强</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojp755q.html">将 Net 项目升级 Core项目经验：（一）迁移Net项目为Net Core&bsol;Standard项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z5xx39.html">用Python浅析股票数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yr55z8.html">个人建站&amp;amp&semi;mac下安装hexo</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey6plk9.html">&lbrack;BZOJ 5055&rsqb;膜法师</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m57k48.html">&lbrack;USACO07NOV&rsqb;牛继电器Cow Relays</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gey1yz8.html">PKUWC2018划水记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
